/* BlinkenLib
   Copyright 2004-2014 Stefan Schuermans <stefan@schuermans.info>
   Copyleft GNU public license - http://www.gnu.org/copyleft/gpl.html
   a blinkenarea.org project */

#ifndef INC_BlinkenLib_BlinkenProtoIntern
#define INC_BlinkenLib_BlinkenProtoIntern

#ifdef WIN32
#include <windows.h>
typedef WORD uint16_t;
typedef DWORD uint32_t;
#else
#include <stdint.h>
#endif

// blinken protocol headers
typedef struct sBlinkenProtoBlpHdr {
  uint32_t magic;
  uint32_t frameNo;
  uint16_t width;
  uint16_t height;
} stBlinkenProtoBlpHdr;
#define BlinkenProtoBlpMagic 0xDEADBEEF
#define BlinkenProtoBlpReqMagic 0xDEADBECD
#define BlinkenProtoBlpInfoMagic 0xDEADBE23
typedef struct sBlinkenProtoEblpHdr {
  uint32_t magic;
  uint32_t frameNo;
  uint16_t width;
  uint16_t height;
} stBlinkenProtoEblpHdr;
#define BlinkenProtoEblpMagic 0xFEEDBEEF
#define BlinkenProtoEblpInfoMagic 0xFEEDBE23
typedef struct sBlinkenProtoMcufHdr {
  uint32_t magic;
  uint16_t height;
  uint16_t width;
  uint16_t channels;
  uint16_t maxval;
} stBlinkenProtoMcufHdr;
#define BlinkenProtoMcufMagic 0x23542666
#define BlinkenProtoMcufReqMagic 0x42424242
#define BlinkenProtoMcufEndReqMagic 0x42424243
#define BlinkenProtoMcufInfoMagic 0x42424223

#endif // #ifndef INC_BlinkenLib_BlinkenProtoIntern
